#ifdef BEGIN_MAPPER
#include "mappers.hh" // SECOND INCLUSION

map<unsigned, mapper *>mappers;

BEGIN_MAPPER(1, pos=reg=0;memset(regs,0,sizeof regs);regs[0]=0xC)
	BYTE reg;
	BYTE pos;
	BYTE regs[4];
	
	virtual void write(fWORD ofs, fBYTE value)
	{
	//	fprintf(stderr, "Mapper 1: [%04X] <- %02X\n", ofs, value);
		if(value&0x80)
			pos=reg=0;
		else
		{
			reg |= (value&1) << pos;
			if(++pos==5)
			{
			//	fprintf(stderr, "Mapper 1: Reg value therefore %02X\n", reg);
				regs[ofs / 0x2000 - 4] = reg;
				rewrite();
				pos = reg = 0;
			}
		}
	}
	void rewrite()
	{
		reset();
		if(regs[0] & 8)
			maprom(4, (regs[0] & 4) ? 0 : 4, regs[3]);
		else
			maprom(8, 0, regs[3]);
		update();
	}
END_MAPPER(1)

BEGIN_MAPPER(2, (void)0)
	virtual void write(fWORD ofs, fBYTE value)
	{
		maprom(4, 0, value);
	}
END_MAPPER(2)

BEGIN_MAPPER(4, (void)0)
	BYTE cmd;
	virtual void write(fWORD ofs, fBYTE value)
	{
		fprintf(stderr, "Mapper 4: [%04X] <- %02X\n", ofs, value);
		if(ofs==0x8000)
		{
			exchange(0, 2, 0, 4, value&64);
			
			cmd = value & 7;
			update();
		}
		else if(ofs==0x8001)
		{
			switch(cmd)
			{
				case 6: maprom(2, 0, value); break;
				case 7: maprom(2, 2, value); break;
			}
			update();
		}
	}
END_MAPPER(4)

BEGIN_MAPPER(7, (void)0)
	virtual void write(fWORD ofs, fBYTE value)
	{
		maprom(8, 0, value & 15);
	}
END_MAPPER(7)
#else
#error mappers.cc is not to be compiled individually!
#endif
