#ifndef BisqPAPU_h
#define BisqPAPU_h

#include <cstdio>
#include <unistd.h>
#include "defs.h"
#include "papu_internals.hh"

class bisqpapu
{
	int fd;
	int Rate;
	
	sq1gen chan1;
	sq2gen chan2;
	trigen chan3;
	rndgen chan4;
	dmcgen chan5;
	
	double counter, speed;
	
	inline void mixbytes(unsigned count)
	{
		static const BYTE dutyvalues[4] = {2,4,8,12};
        static const BYTE triangledata[32]=
        {13,14,15,15, 14,13,12,11, 10, 9, 8, 7,  6, 5, 4, 3,
          2, 1, 0, 0,  1, 2, 3, 4,  5, 6, 7, 8,  9,10,11,12};
        
		// chan1 = +-15, chan2 = +-15
		// chan3 = 
		
		BYTE val1 = chan1.getvol() * ((chan1.dutycounter&15) < dutyvalues[chan1.dutytype] ? -1 : 1);
		BYTE val2 = chan2.getvol() * ((chan2.dutycounter&15) < dutyvalues[chan2.dutytype] ? -1 : 1);
		BYTE val3 = triangledata[chan3.trianglecounter&31];
		BYTE val4 = chan4.getvol() * chan4.output;
		
		// val1, val2:   -15 .. +15
		// val3: 0..15
		// val4: 0..15
		
        register short d = (val1+val2-val3+val4) // range: -15-15-15+0 .. 15+15-0+15 = -45..+45
                         * (32767/45);
        
        register BYTE lo = d&255;
        register BYTE hi = d>>8;
        register fWORD b = count*2;
        BYTE buf[b];        
        for(register fWORD a=0; a<b; )
        {
        	buf[a++] = lo;
        	buf[a++] = hi;
		}
		std::write(fd, buf, b);
	}
	
public:
	bisqpapu();
	~bisqpapu();
	
	bool write(const fWORD addr, fBYTE value);
	bool read(const fWORD addr, BYTE &value);
	
	InterruptType tick();
};

#endif
